// mpichler, 19950801
#ifdef PMAX
enum Part { goofyPart };        // confused about QvCone::Part and QvCylinder::Part
enum Binding { goofyBinding };  // confused about QvMaterialBinding/QvNormalBinding::Binding
#endif

// mpichler, 19950802
#if defined(PMAX) || defined(PMAX_GNU)
#  include <string.h>
#  include <malloc.h>
char* strdup (const char* s)  // strdup not contained in system libraries
{
  char* p = (char*) malloc (strlen (s) + 1);
  if (p)
    strcpy (p, s);
  return p;
}
#endif

#include <QvNode.h>

// anuss: node names
// (must correspond to QvNodeType enum)
const char* const qvNodeName[QvNodeType::qv_num_nodes] =
{ 
  "AsciiText", "Cone", "Coordinate3", "Cube", "Cylinder",
  "DirectionalLight", "FontStyle", "Group", "IndexedFaceSet",
  "IndexedLineSet", "Info", "LOD", "Material", "MaterialBinding",
  "MatrixTransform", "Normal", "NormalBinding", "OrthographicCamera",
  "PerspectiveCamera", "PointLight", "PointSet", "Rotation", "Scale",
  "Separator", "ShapeHints", "Sphere", "SpotLight", "Switch",
  "Texture2", "Texture2Transform", "TextureCoordinate2", "Transform",
  "TransformSeparator", "Translation", "WWWAnchor", "WWWInline",
  "UnknownNode", "Label", "LightModel"
};


// changed by Gerbert Orasche 260695
#ifdef __PC__
#pragma warning(disable:4244)
#endif

// mpichler, 19951109
// definition of a suffix would be sufficient for compilers,
// but UNIX' makedepend does not check this
// e.g. #define CPPSUFFIX ".C"
// #include "QvXXX" CPPSUFFIX
// gorasche, 19960229
// VC++ now rejects them too, so we're back to the old, large ifdef


#ifdef __PC__

/* #define CPPSUFFIX ".cpp" */

# include "QvAsciiText.cpp"
# include "QvChildList.cpp"
# include "QvCone.cpp"
# include "QvCoordinate3.cpp"
# include "QvCube.cpp"
# include "QvCylinder.cpp"
# include "QvDB.cpp"
# include "QvDebugError.cpp"
# include "QvDict.cpp"
# include "QvDirectionalLight.cpp"
# include "QvElement.cpp"
# include "QvField.cpp"
# include "QvFieldData.cpp"
# include "QvFontStyle.cpp"
# include "QvGroup.cpp"
# include "QvIndexedFaceSet.cpp"
# include "QvIndexedLineSet.cpp"
# include "QvInfo.cpp"
# include "QvInput.cpp"
# include "QvLists.cpp"
# include "QvLOD.cpp"
# include "QvMFColor.cpp"
# include "QvMFFloat.cpp"
# include "QvMFLong.cpp"
# include "QvMFString.cpp"
# include "QvMFVec2f.cpp"
# include "QvMFVec3f.cpp"
# include "QvMaterial.cpp"
# include "QvMaterialBinding.cpp"
# include "QvMatrixTransform.cpp"
# include "QvName.cpp"
# include "QvNode.cpp"
# include "QvNormal.cpp"
# include "QvNormalBinding.cpp"
# include "QvOrthographicCamera.cpp"
# include "QvPList.cpp"
# include "QvPerspectiveCamera.cpp"
# include "QvPointLight.cpp"
# include "QvPointSet.cpp"
# include "QvReadError.cpp"
# include "QvRotation.cpp"
# include "QvSFBitMask.cpp"
# include "QvSFBool.cpp"
# include "QvSFColor.cpp"
# include "QvSFEnum.cpp"
# include "QvSFFloat.cpp"
# include "QvSFImage.cpp"
# include "QvSFLong.cpp"
# include "QvSFMatrix.cpp"
# include "QvSFRotation.cpp"
# include "QvSFString.cpp"
# include "QvSFVec2f.cpp"
# include "QvSFVec3f.cpp"
# include "QvScale.cpp"
# include "QvSeparator.cpp"
# include "QvShapeHints.cpp"
# include "QvSphere.cpp"
# include "QvSpotLight.cpp"
# include "QvState.cpp"
# include "QvString.cpp"
# include "QvSwitch.cpp"
# include "QvTexture2.cpp"
# include "QvTexture2Transform.cpp"
# include "QvTextureCoordinate2.cpp"
# include "QvTransform.cpp"
# include "QvTransformSeparator.cpp"
# include "QvTranslation.cpp"
# include "QvUnknownNode.cpp"
# include "QvWWWAnchor.cpp"
# include "QvWWWInline.cpp"

# ifdef VRMLEXTENSIONS
#  include "QvExtensions.cpp"
# endif

#else

/* #define CPPSUFFIX ".C" */

# include "QvAsciiText.C"
# include "QvChildList.C"
# include "QvCone.C"
# include "QvCoordinate3.C"
# include "QvCube.C"
# include "QvCylinder.C"
# include "QvDB.C"
# include "QvDebugError.C"
# include "QvDict.C"
# include "QvDirectionalLight.C"
# include "QvElement.C"
# include "QvField.C"
# include "QvFieldData.C"
# include "QvFontStyle.C"
# include "QvGroup.C"
# include "QvIndexedFaceSet.C"
# include "QvIndexedLineSet.C"
# include "QvInfo.C"
# include "QvInput.C"
# include "QvLists.C"
# include "QvLOD.C"
# include "QvMFColor.C"
# include "QvMFFloat.C"
# include "QvMFLong.C"
# include "QvMFString.C"
# include "QvMFVec2f.C"
# include "QvMFVec3f.C"
# include "QvMaterial.C"
# include "QvMaterialBinding.C"
# include "QvMatrixTransform.C"
# include "QvName.C"
# include "QvNode.C"
# include "QvNormal.C"
# include "QvNormalBinding.C"
# include "QvOrthographicCamera.C"
# include "QvPList.C"
# include "QvPerspectiveCamera.C"
# include "QvPointLight.C"
# include "QvPointSet.C"
# include "QvReadError.C"
# include "QvRotation.C"
# include "QvSFBitMask.C"
# include "QvSFBool.C"
# include "QvSFColor.C"
# include "QvSFEnum.C"
# include "QvSFFloat.C"
# include "QvSFImage.C"
# include "QvSFLong.C"
# include "QvSFMatrix.C"
# include "QvSFRotation.C"
# include "QvSFString.C"
# include "QvSFVec2f.C"
# include "QvSFVec3f.C"
# include "QvScale.C"
# include "QvSeparator.C"
# include "QvShapeHints.C"
# include "QvSphere.C"
# include "QvSpotLight.C"
# include "QvState.C"
# include "QvString.C"
# include "QvSwitch.C"
# include "QvTexture2.C"
# include "QvTexture2Transform.C"
# include "QvTextureCoordinate2.C"
# include "QvTransform.C"
# include "QvTransformSeparator.C"
# include "QvTranslation.C"
# include "QvUnknownNode.C"
# include "QvWWWAnchor.C"
# include "QvWWWInline.C"
# include "QvMFFace.C"  /* Georg Meszaros, 19960329 */

# ifdef VRMLEXTENSIONS
#  include "QvExtensions.C"
# endif

#endif
